﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;

[ExecuteInEditMode]
public class DrawMeshInstanced : MonoBehaviour
{
    public Mesh mesh;
    public Material mat;

    private List<Color> _colors = new List<Color>();
    private List<Vector3> _positions = new List<Vector3>();

    public int NumInstances;
    public int SpawnRegionSize;

    void OnEnable()
    {
        _colors.Clear();
        _positions.Clear();
    }

    void OnRenderObject()
    {
        if(_colors.Count == 0)
        {
            _colors = new List<Color>();
            for (int i = 0; i < NumInstances; i++)
            {
                _colors.Add(new Color(Random.value, Random.value, Random.value));
            }
        }

        if (_positions.Count == 0)
        {
            _positions = new List<Vector3>();
            for (int i = 0; i < NumInstances; i++)
            {
                _positions.Add(Random.insideUnitSphere * SpawnRegionSize);
            }
        }

        // Draw multiple instances
        for(int i = 0; i< _colors.Count; i++)
        {
            mat.color = _colors[i];

            mat.SetPass(0);
            Graphics.DrawMeshNow(mesh, _positions[i], Quaternion.identity); 
        }        
    }
}
