﻿Shader "Custom/DrawRandomProcedural"
{
	SubShader
	{
		Tags{ "RenderType" = "Opaque" }
		LOD 100

		Pass
		{
			Cull Off

			CGPROGRAM
			#pragma vertex vert
			#pragma fragment frag

			#include "UnityCG.cginc"

			StructuredBuffer<float4> _RandomColors;
			StructuredBuffer<float3> _RandomVertices;

			struct v2f
			{
				float4 vertex : SV_POSITION;
				float4 color : COLOR0;
			};

			v2f vert(uint vertexId : SV_VertexID)
			{							
				float4 color = _RandomColors[vertexId];
				float3 vertex = _RandomVertices[vertexId];

				v2f output;
				output.color = color;
				output.vertex = mul(UNITY_MATRIX_MVP, float4(vertex,1));
				return output;
			}

			float4 frag(v2f i) : SV_Target
			{				
				return i.color;			
			}

			ENDCG
		}
	}
}

